<?php

/* mailbox.php: main page that displays the message list for the selected mailbox 
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: mailbox.php,v 1.375 2006/01/12 08:50:16 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'mailbox');

/* Login to Hastymail */
if (isset($hm_input['login'])) {
    $imap_stream = hm_hastymail_login($hm_input, $config_file, $hasty_key);
    $_SESSION['toolbar_defaults'] = $toolbar_defaults;
    if (empty($_SESSION['settings'])) {
        $_SESSION['settings'] = $defaults;
    }
    $config = $_SESSION['config'];
    $str = $_SESSION['str'];
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
        if (!isset($config['no_auto_simplify']) || 
            $config['no_auto_simplify'] != 'true') {
            if (hm_browser_type ($_SERVER['HTTP_USER_AGENT'], true)) {
                $_SESSION['auto_simplify'] = 'true';
            }
        }
        if (isset($config['always_simplify']) && $config['always_simplify'] == 'true') {
            $_SESSION['settings']['simple'] = 'true';
        }
        if (isset($config['enable_nn4_workarounds']) && 
            $config['enable_nn4_workarounds'] == 'true' &&
            substr($_SERVER['HTTP_USER_AGENT'], 0, 9) == 'Mozilla/4' &&
            !strstr($_SERVER['HTTP_USER_AGENT'], 'MSIE')) {
            $_SESSION['settings']['css_file'] = 'smokesky_nn4.css';
            $_SESSION['nn4_warning'] = true;
        }
    }
    
    /* get the folder list */
    $_SESSION['folders'] = hm_boxlist($imap_stream, true, 'all');
    if (!isset($_SESSION['settings']['new_mail_folders'])) {
        $_SESSION['settings']['new_mail_folders'] = array ('INBOX');
    }
    if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 
        'true' || isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] ==
        'true') && isset($_SESSION['settings']['fold_simple']) &&
        $_SESSION['settings']['fold_simple'] == 'true') {
        foreach ($_SESSION['settings']['new_mail_folders'] as $val) {
            $_SESSION['settings']['folded'][$val] = 1;
        }
    }
    /* very first time we are logging in, check for autocreate folder
       settings */
    if (isset($_SESSION['first_login'])) {
        $defaults['date_string'] = $defaults['time_format'].' '.$defaults['date_format'];
        $_SESSION['settings'] = array_merge($_SESSION['settings'], $defaults);
        require_once('../lib/imap_3.php');
        hm_autocreate_folders($imap_stream, $config);
        hmw_write_settings($_SESSION['user'], $config); 
    }
    if (!isset($_SESSION['dsp_folders'])) {
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
    }
    if (isset($_SESSION['settings']['default_folder'])) {
        $cur_folder = $_SESSION['settings']['default_folder'];
    }
    else {
        $cur_folder = 'INBOX';
    }
    /* redirect to non-standard start page */
    if (isset($hm_input['login_message_view'])) {
        header("Location: ".$_SESSION['config']['hostname'].
                $_SESSION['config']['install_path'].'message.php?id='.session_id().
                $hm_input['login_message_view']);
    }
    elseif (isset($_SESSION['settings']['start_page']) && 
        $_SESSION['settings']['start_page'] != '' &&
        $_SESSION['settings']['start_page'] != 'mailbox.php') {
        hm_imap_logout($imap_stream);
        header("Location: ".$_SESSION['config']['hostname'].
                $_SESSION['config']['install_path'].$_SESSION['settings']['start_page'].
                '?id='.session_id().'&mailbox='.$cur_folder);
        exit;
    }
    else {
        hm_imap_logout($imap_stream);
        header("Location: ".$_SESSION['config']['hostname'].
                $_SESSION['config']['install_path'].'mailbox.php?id='.session_id().
                '&mailbox='.$cur_folder);
        exit;
    }
}
/* already logged in, so restart the session */
else {
    if (isset($hm_input['new_session'])) {
        hm_session_continue($hm_input['id'], $config_file, true, false, true);
        if (isset($_SESSION['settings']['default_folder'])) {
            $hm_input['mailbox'] = $_SESSION['settings']['default_folder'];
        }
        $_SESSION['notices'][] = 'SESSION ID randomized';
    }
    else { 
        hm_session_continue($hm_input['id'], $config_file);
    }
    $config = $_SESSION['config'];
    $str = $_SESSION['str'];
    if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                      $hasty_key, false, false)) {
        hm_logged_out($config_file); 
    }
}

/* check some values and setup some basic vars */

$config = $_SESSION['config'];
if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}

$hm_input['id'] = session_id();
$sort_types = $str['sort_types'];
if (isset($_SESSION['caps']) && !stristr($_SESSION['caps'], 'THREAD')) {
    $sort_types = array_slice($sort_types, 0, -2);
}

/* move to destination */ 
if (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
if (isset($hm_input['move']) || isset($hm_input['copy'])) {
    $dest = $hm_input['destination'];
}
if (isset($hm_input['move2']) || isset($hm_input['copy2'])) {
    $dest = $hm_input['destination2'];
}
$_SESSION['move_to_destination'] = $dest;

/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* check for keep_as_new */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder'], false, true);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* default page number */
if (!isset($hm_input['page_num'])) {
    $hm_input['page_num'] = 0;
}
/* if the lower set of controls were used */
if (isset($hm_input['submit_page2'])) {
    $hm_input['submit_page'] = $hm_input['submit_page2'];
    $hm_input['page'] = $hm_input['page2'];
}
/* check to see if we loaded this page from a prev/next button */
switch (true) {
    /* prev */
    case (isset($hm_input['prev']) && isset($hm_input['psubmit'])):
        $hm_input['page_num'] = $hm_input['prev'];
        break;
    /* next */
    case (isset($hm_input['next']) && isset($hm_input['nsubmit'])):
        $hm_input['page_num'] = $hm_input['next'];
        break;
    /* jump to page */
    case (isset($hm_input['submit_page'])): 
        $hm_input['page_num'] = $hm_input['page'];
        break;
    /* nada */
    default:
        break;
    }

/* if we are moving/copying/deleting/etc. messages */
$resort = false;
$large = false;
$sort = false;

if (!isset($hm_input['uid_string'])) {
    $uid_string = '';
}
else {
    $uid_string = $hm_input['uid_string'];
}
$action = false;
switch (true) {
    case isset($hm_input['purge']):
        $action = 'delete';
        $hm_input['selection_type'] = 'all';
        break;
    case isset($hm_input['move2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
        $hm_input['destination'] = $hm_input['destination2'];
    case isset($hm_input['move']):
        $action = 'move';
        break;
    case isset($hm_input['sort2']):
        $hm_input['sort_type'] = $hm_input['sort_type2'];
    case isset($hm_input['sort']):
        $action = 'sort';
        break;
    case isset($hm_input['delete2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['delete']):
        $action = 'delete';
        if (isset($hm_input['skip_trash2'])) {
            $hm_input['skip_trash'] = $hm_input['skip_trash2'];
        }
        break;
    case isset($hm_input['read2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['read']):
        $action = 'read';
        break;
    case isset($hm_input['flag2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['flag']):
        $action = 'flag';
        break;
    case isset($hm_input['unflag2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['unflag']):
        $action = 'unflag';
        break;
    case isset($hm_input['unread2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['unread']):
        $action = 'unread';
        break;
    case isset($hm_input['expunge2']):
    case isset($hm_input['expunge']):
        $hm_input['selection_type'] = 'all';
        $action = 'expunge';
        break;
    case isset($hm_input['copy2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
        $hm_input['destination'] = $hm_input['destination2'];
    case isset($hm_input['copy']):
        $action = 'copy';
        break;
    default:
        break;
}
/* process message action */
if ($action) {
    $tmp_box = hm_select_mailbox($imap_stream, $hm_input['mailbox']);
    if (isset($tmp_box) && $tmp_box != $hm_input['mailbox']) {
        $hm_input['mailbox'] = $tmp_box;
    }
    $resort = true;
    if (isset($hm_input['selection_type'])) {
        /* selected messages */
        if ($hm_input['selection_type'] == 'marked') {
            $dsp_count = 0;
            foreach($_POST as $index => $value) {
                if ($value == 'mark') {
                    $dsp_count++;
                    $uid_string .= $index.',';
                }
            }
        }
        /* one page of messages */
        elseif($hm_input['selection_type'] == 'page') {
            $dsp_count = count(split(",", $hm_input['page_string']));
            $uid_string = $hm_input['page_string'];
        }
        /* all messages */
        elseif($hm_input['selection_type'] == 'all') {
            $sort_tmp = $_SESSION['sort_data'][$hm_input['mailbox']];
            $dsp_count = count($sort_tmp[2]);
            if ($dsp_count > 1000) {
                $large = $hm_input['mailbox'];
            }
            $uid_string = implode(',', $sort_tmp[2]);
            unset($sort_tmp);
        }
    }
    elseif (isset($hm_input['uid_delete'])) {
        $dsp_count = 1;
        $uid_string = $hm_input['uid_delete'];
    }
    elseif (isset($hm_input['uid_move'])) {
        $dsp_count = 1;
        $uid_string = $hm_input['uid_move'];
    }
    if ($dsp_count > 1) {
        $dsp_end = $str[18];
    }
    else {
        $dsp_end = $str[26];
    }
    $srt = false;
    if (isset($hm_input['sort_type'])) {
        $srt = $hm_input['sort_type'];
    }
    if (!isset($hm_input['destination'])) {
        $hm_input['destination'] = '';
    }
    if ($action == 'delete' && isset($hm_input['skip_trash'])) {
        $skip = true;
    }
    else {
        $skip = false;
    }
    $sort = hm_message_controls ($action, $imap_stream, $uid_string, 
                                   $hm_input['destination'], $large, $srt, 
                                   $hm_input['mailbox'], $dsp_count, $dsp_end,
                                   $skip);
}

/* update counts and check the cache */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);
$tmp_box = hm_select_mailbox($imap_stream, $hm_input['mailbox']);
if (isset($tmp_box) && $tmp_box != $hm_input['mailbox']) {
    $hm_input['mailbox'] = $tmp_box;
}
$cache = hm_check_cache($hm_input['mailbox']);

/* get the sort information for this mailbox/page */
if ($sort) {
    $_SESSION['settings']['sort'][$hm_input['mailbox']] = $sort;
}

if (isset($_SESSION['settings']['sort']) && 
    array_key_exists($hm_input['mailbox'], $_SESSION['settings']['sort'])) {
    $sort = $_SESSION['settings']['sort'][$hm_input['mailbox']];
} 
elseif (isset($_SESSION['settings']['sort']) &&
    array_key_exists(urlencode($hm_input['mailbox']), $_SESSION['settings']['sort'])) {
    $sort = $_SESSION['settings']['sort'][urlencode($hm_input['mailbox'])];
} 
else {
    $sort = 'ARRIVAL';
}
if (isset($hm_input['sort2'])) {
    $hm_input['sort_filter'] = $hm_input['sort_filter2'];
    $hm_input['sort'] = $hm_input['sort2'];
}
if (isset($hm_input['sort_filter'])) {
    if (isset($hm_input['sort'])) {
        if ($hm_input['sort_filter'] != 'None') {
            $filter = $hm_input['sort_filter'];
        }
        else {
            $filter = false;
        }
    }
    elseif (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
        $filter = $_SESSION['sort_filter'][$hm_input['mailbox']];
    }
    else {
        $filter = false;
    }
}
else {
    if (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
        $filter = $_SESSION['sort_filter'][$hm_input['mailbox']];
    }
    else {
        $filter = false;
    }
}
$reuse = true;
if ($cache && !$resort) {
    $sort_info = $_SESSION['sort_data'][$hm_input['mailbox']];
}
else {
    if (isset($_SESSION['thread_data'][$hm_input['mailbox']])) {
        unset($_SESSION['thread_data'][$hm_input['mailbox']]);
    }
    $reuse = false;
    $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false,
                                    $filter);
    if ($filter && !$sort_info) {
        $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false);
        $filter = false;
        $_SESSION['notices'][] = $str[341];
    }
}
if ($filter) {
    if (!isset($_SESSION['sort_filter'])) {
        $_SESSION['sort_filter'] = array();
    }
    $_SESSION['sort_filter'][$hm_input['mailbox']] = $filter;
}
else {
    if (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
        unset($_SESSION['sort_filter'][$hm_input['mailbox']]);
    }
}

/* reply notice check */
if (isset($hm_input['reply_notice'])) {
    hm_imap_action($imap_stream, $hm_input['reply_notice'], 'ANSWERED');
    $_SESSION['notices'][] = $str[42];
}

/* check for missing folders */
hm_check_folders($imap_stream);

/* check for unseen message changes from other clients */
if (in_array($hm_input['mailbox'], $_SESSION['settings']['new_mail_folders'])) {
    $unread_check = hm_search_mailbox($imap_stream, 'SEARCH UNSEEN');
    if ($unread_check != '') {
        $unread_check = count(explode(' ', $unread_check));
    }
    else {
        $unread_check = 0;
    }
    $_SESSION['unseen'][$hm_input['mailbox']] = $unread_check;
    $unseen[$hm_input['mailbox']] = $unread_check;
}

/* toolbar and any status messages */
$page_data = array();
if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}
list($page_data['td'], $page_data['hd']) = 
        hm_toolbar2($imap_stream, $hm_input['mailbox'], $unseen, false, $str[220]);

/* create the contols for the top of the message table */
$dsp_folders = $_SESSION['dsp_folders'];
if (isset($_SESSION['nn4_warning'])) {
    $page_data['nn4'] = true;
}
else {
    $page_data['nn4'] = false;
}
if (isset($config['utf7_decode'])) {
    $page_data['folder_name'] = utf8_encode(imap_utf7_decode($dsp_folders[urldecode(
                               $hm_input['mailbox'])]));
}
else {
    $page_data['folder_name'] = $dsp_folders[urldecode($hm_input['mailbox'])];
}
if (is_array($sort_info) && !empty($sort_info)) {
    $page_data['not_empty'] = true;
    $page_data['filter'] = $filter;
    $prev_btn = false;
    $next_btn = false;
    if (!array_key_exists($hm_input['page_num'], $sort_info[1])) {
        $hm_input['page_num'] = 0;
    }
    if ($filter) {
        $page_data['filter_name'] = $str[342];
    }
    if ($hm_input['page_num'] > 0) {
        $prev_btn = 1;
        $hm_input['prev'] = $hm_input['page_num'] - 1;
        $page_data['input_prev'] = $hm_input['prev'];
    }
    $page_data['lbl_btn_page'] = $str[9];
    
    $page_options = '';
    foreach ($sort_info[1] as $index => $array) {
        $page_options .= "<option value=\"$index\" ";
        if ($index == $hm_input['page_num']) {
            $page_options .= 'selected';
        }
        $page_options .= ">".($index+1)."</option>";
    }
    $page_data['page_options'] = $page_options;
    
    if ($sort_info[0] > $sort_info[1][$hm_input['page_num']][1]) { 
        $next_btn = 1;
        $next = $hm_input['page_num'] + 1;
        $page_data['input_next'] = $next;
    }
    $page_data['prev_button'] = $prev_btn;
    $page_data['next_button'] = $next_btn;
    $page_data['input_id'] = $hm_input['id'];
    $page_data['input_mailbox'] = $hm_input['mailbox'];
    if (isset($_SESSION['palm'])) {
        $page_data['palm'] = true;
    }
    else {
        $page_data['palm'] = false;
    } 
    if (!$page_data['palm']) {
        $page_data['lbl_btn_sort'] = $str[17];
        if (isset($_SESSION['config']['client_sort']) && 
            $_SESSION['config']['client_sort'] == 'true') {
            $sort_types = $str['client_sort_types'];
        }
        $page_data['sort_types'] = $sort_types;
        $page_data['sort'] = $sort;
        $page_data['lbl_btn_filter'] = $str[329];
        $sort_filter_types = array(
            'None' => $str[330], 
            'SEEN' => $str[2], 
            'UNSEEN' => $str[3], 
            'FLAGGED' => $str[327], 
            'UNFLAGGED' => $str[328], 
            'ANSWERED' => $str[67], 
            'UNANSWERED' => $str[68], 
            'DELETED' => $str[89],
            'UNDELETED' => $str[70],
            'HEADER content-type multipart' => $str[331]
        );
        $page_data['sort_filter_types'] = $sort_filter_types;
    }
    $t_all = false;
    if (isset($hm_input['toggle_all'])) {
        $t_all = true;
    }
    $headers = hm_get_messages (implode(',', $sort_info[1][$hm_input['page_num']][2]),
                                $imap_stream);
    $count = count($headers);
    $sort_page = $sort_info[1][$hm_input['page_num']][2];
    $page_data['input_page_string'] = implode(',', $sort_page);
    $page_data['input_page_num'] =  $hm_input['page_num'];
    $page_data['num_messages'] = "{$sort_info[0]} {$str[18]}";
    $page_data['viewing_messages'] = $str[19].' '.$sort_info[1][$hm_input['page_num']][0].
                                     ' - '.$sort_info[1][$hm_input['page_num']][1];
    if (isset($_SESSION['settings']['trash_folder']) &&
        $_SESSION['settings']['trash_folder'] == urldecode($hm_input['mailbox'])) {
        $page_data['lbl_btn_trash'] = $str[20];
    }
    else {
        $page_data['lbl_btn_trash'] = false;
    }
    $page_data['mc'] = hm_print_message_controls2(array('marked'=>$str[6],
                                     'page'=>$str[7],'all'=>$str[8]), $dest, $simple);
    $page_data['subject_lbl'] = $str[21];
    if ((isset($_SESSION['settings']['sent_folder']) && 
       $_SESSION['settings']['sent_folder'] == urldecode($hm_input['mailbox'])) ||
       (isset($_SESSION['settings']['drafts_folder']) &&
       $_SESSION['settings']['drafts_folder'] == urldecode($hm_input['mailbox']) &&
       $hm_input['mailbox'] != 'INBOX')) {
        $page_data['from_lbl'] = $str[25];
    }
    else {
        $page_data['from_lbl'] = $str[22];
    }
    $page_data['date_lbl'] = $str[23];
    $page_data['size_lbl'] = $str[24];
    $rows = array();
    for ($i=0;$i<$count;$i++) {
        $current = false;
        if (isset($hm_input['uid']) && $hm_input['uid'] == $sort_page[$i]) {
            $current = true;
        }
        $rows[] = hm_print_row2($headers[$sort_page[$i]], $t_all, $hm_input['mailbox'],
                        $hm_input['id'], $sort_page[$i], $sort_info, true, false, false,
                        false, $current);
    }
    $page_data['rows'] = $rows;
    $page_data['num_rows']  = $count;
    if ($reuse) {
        $page_data['reuse'] = 'cached';
    }
    else {
        $page_data['reuse'] = 'fetched';
    }
    $page_data['purge_lbl'] = $str[20];
    
}
else {
    $dsp_folders = $_SESSION['dsp_folders'];
    $page_data['not_empty'] = false;
    $page_data['lbl_empty'] = $str[54];
}

/* close imap connection */
hm_imap_logout ($imap_stream);

$page_data['lbl_top'] = $str[324];
$page_data['start_time'] = $start;

/* output HTTP headers */
hm_output_http_headers();

if (isset($_SESSION['settings']['folder_size'])) {
    $page_data['folder_size'] = $_SESSION['settings']['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}

/* output page */
if ($simple) {
    hm_output_page($page_data, 'mailbox_template.php', 'simple');
}
else {
    hm_output_page($page_data, 'mailbox_template.php', $template_set);
}

?>
