<?php

/*  toolbar_template.php:  Template for the page headers and toolbar
*
* $Id: toolbar_template.php,v 1.15 2006/01/19 21:29:12 sailfrog Exp $
*/

/* get CSS file and font size for selected theme */

if (!isset($_SESSION['settings']['css_file'])) {
    if (!isset($_SESSION['config']['default_theme']) ||
        $_SESSION['config']['default_theme'] == '') {
        $css_file = 'default.css';
    }
    else {
        $css_file = $_SESSION['config']['default_theme'];
    }
}
else {
    $css_file = $_SESSION['settings']['css_file'];
}

/* work around old theme setting */
$css = str_replace(array('_large', '_small'), '', strtolower($css_file));
if (isset($_SESSION['settings']['font_size'])) {
    if ($_SESSION['settings']['font_size'] < 3) {
        switch ($_SESSION['settings']['font_size']) {
            case 0:
                $font_size = 11;
            case 1:
                $font_size = 9;
            case 2:
                $font_size = 12;
            default:
                $font_size = 11;
        }
    }
    else {
        $font_size = $_SESSION['settings']['font_size'];
    }
}    
else {
    $font_size = 11;
}
$stylesheet  = '<link rel="stylesheet" type="text/css" href="../html/style.php?style='.
               $css.'&amp;size='.$font_size.'">';

/* HTML headers */
echo '
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
    <meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=',$hd['charset'],'"> 
    <title>
    ',$hd['title_prefix'],' (',$hd['total_unread'],') |',$hd['page_title'],'
    </title>
    ',$stylesheet;
    if ($hd['refresh']) { echo ' 
    ',$hd['refresh_meta']; } echo '
    <link rel="SHORTCUT ICON" href="../images/hastymail.ico">
</head>
<body>
<a name="top"></a>';

/* debug stuff */
$debug_title = '';
if (isset($_SESSION['cache_size'])) {
    $debug_title .=  'csize:'.$_SESSION['cache_size'].'|';
    unset($_SESSION['cache_size']);
}
if (isset($_SESSION['cached_folders'])) {
    $debug_title .=  'cfolders:'.$_SESSION['cached_folders'].'|';
    unset($_SESSION['cached_folders']);
}
if (isset($reuse)) {
    $debug_title .=  'current:'.$reuse.'|';
}
$debug_title .=  'IMAP calls:'.$_SESSION['counter'].'';
if (isset($_SESSION['piped'])) {
    $debug_title .=  '('.$_SESSION['piped'].'pipelined)';
    unset($_SESSION['piped']);
}
if (isset($start_time)) {
    $debug_title .=  '|time:'.(hm_time() - $start_time);
}

/* toolbar */
echo 
'<form action="redirect.php" method="post">
<table width="100%" align="center">
    <tr>
        <td class="tables2" width="1%">
        <table align="center" width="100%" cellpadding="2" cellspacing="2" class="tables1">
            <tr>';
            if ($td['wide_bar']) { echo '
                <td align="center" rowspan="2" valign="top" width="29">';
            } else { echo '
                <td align="center" valign="middle" width="29">';
            } echo '
                <a href="about.php?id=',$td['session_id'],'&amp;mailbox=',urlencode($td['mailbox_val']),'">
                <img title="',$debug_title,'" src="../images/hastymail.png" width="28" height="23" border="0" alt="H"></a>
                </td>';
            if ($td['show_clock']) { echo '
                <td align="center" nowrap valign="middle">
                <table class="tables2" cellpadding="2" cellspacing="0">
                    <tr>
                        <td class="tables1" nowrap>
                        <small>&nbsp;',$td['date_string'],'&nbsp;</small>
                        </td>
                    </tr>
                </table>
                </td>';
            } echo '
                <td nowrap valign="middle">
                <select name="toolbar_mailbox">';
            foreach ($td['folder_dropdown_data'] as $val): echo $val; endforeach; echo '
                </select>
                &nbsp;&nbsp;
                <input type="submit" name="go" value="',$td['go_lbl'],'" class="button1">
                </td>';
            if ($td['wide_bar']) { echo '
                <td width="75%"></td></tr><tr><td></td>';
            } echo '
                <td colspan="2" align="right" nowrap>';
            if ($td['tb_defaults']['new']) { echo '
                <input type="submit" name="new" value="',$td['new_lbl'],'" class="button1">'; }
            if ($td['tb_defaults']['search']) { echo '
                <input type="submit" name="search" value="',$td['search_lbl'],'" class="button1">'; }
            if ($td['tb_defaults']['options']) { echo '
                <input type="submit" name="options" value="',$td['options_lbl'],'" class="button1">'; }
            if ($td['tb_defaults']['folders']) { echo '
                <input type="submit" name="folders" value="',$td['folders_lbl'],'" class="button1">'; }
            if ($td['tb_defaults']['contacts']) { echo '
                <input type="submit" name="contacts" value="',$td['contacts_lbl'],'" class="button1">'; }
            if ($td['tb_defaults']['compose']) { echo '
                <input type="submit" name="compose" value="',$td['compose_lbl'],'" class="button1">'; }
            if ($td['tb_defaults']['new_session']) { echo '
                <input type="submit" name="new_session" value="',$td['new_sid_lbl'],'" class="button1">'; }
            echo '
                <input type="submit" name="logout" value="',$td['logout_lbl'],'" class="button1">
                <input type="hidden" name="id" value="',$td['session_id'],'">
                <input type="hidden" name="mailbox" value="',$td['mailbox_val'],'">
                <input type="hidden" name="hostname" value="',$td['hostname'],'">
                <input type="hidden" name="install_path" value="',$td['install_path'],'">
                </td>
            </tr>
        </table>
        </td>
    </tr>
</table>';
if ($td['iframe']) { echo '
<iframe src="iframe.php?id=',$td['session_id'],'" width="0" height="0" frameborder="0" style="{visibility: hidden}">
</iframe>';
}
if (!$td['big_form']) { echo '
</form>
';
}
?>
